﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace InfragisticsSample
{
    // Used to pass report parm data between UI elements
    public class DummyData : INotifyPropertyChanged
    {

        private Int32 _numericValue1 = 0;
        private Int32 _numericValue2 = 0;


        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        public Int32 NumericValue1
        {
            get { return _numericValue1; }
            set
            {
                if (value != null)
                {
                    this._numericValue1 = value;
                    NotifyPropertyChanged("NumericValue1");
                }
            }
        }

        public Int32 NumericValue2
        {
            get { return _numericValue2; }
            set
            {
                if (value != null)
                {
                    this._numericValue2 = value;
                    NotifyPropertyChanged("NumericValue2");
                }
            }
        }

    }

}
