﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Controls;
using Infragistics.Windows.Editors;

namespace InfragisticsSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<DummyData> DummyDataCol = null;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            ReportParmGrid.DataSource = null;
            ReportParmGrid.DataItems.Clear();

            DummyData dummyData = new DummyData();
            DummyDataCol = new ObservableCollection<DummyData>();
            dummyData.NumericValue1 = 10;
            dummyData.NumericValue2 = 20;
            DummyDataCol.Add(dummyData);

            dummyData = new DummyData();
            dummyData.NumericValue1 = 20;
            dummyData.NumericValue2 = 10;
            DummyDataCol.Add(dummyData);

            dummyData = new DummyData();
            dummyData.NumericValue1 = 10;
            dummyData.NumericValue2 = 10;
            DummyDataCol.Add(dummyData);

            ReportParmGrid.DataSource = DummyDataCol;

        }

    }

    /// <summary>
    /// The user is allowed to shift the distribution of hours around manually by entering numbers
    /// into the cells.  If total of all hours entered is less or more than the budgeted hours display
    /// a color.  Otherwise display black.
    /// Was not able to pass in the data record as the parameter.  Created the Depency property so I could
    /// use binding to pass the DataRecord
    /// </summary>

    public class OverOrUnderBudgetedHoursBrushConverter : DependencyObject, IValueConverter
    {
        public static DependencyProperty ConverterDataRecordParameterProperty =
            DependencyProperty.Register("ConverterDataRecordParameter", typeof(Infragistics.Windows.DataPresenter.DataRecord),
            typeof(OverOrUnderBudgetedHoursBrushConverter));

        public Infragistics.Windows.DataPresenter.DataRecord ConverterDataRecordParameter
        {
            get { return (Infragistics.Windows.DataPresenter.DataRecord)GetValue(ConverterDataRecordParameterProperty); }
            set { SetValue(ConverterDataRecordParameterProperty, value); }
        }

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {

            Infragistics.Windows.DataPresenter.DataRecord parmRec = ConverterDataRecordParameter ?? null;
            if (parmRec != null)
            {
                decimal budgetedHours = System.Convert.ToDecimal(parmRec.Cells["LaborHours"].Value);
                decimal enteredHours = System.Convert.ToDecimal(parmRec.Cells["EnteredHours"].Value);
                if (enteredHours < budgetedHours)
                    return Brushes.Green;
                else if (enteredHours > budgetedHours)
                    return Brushes.Red;
                else
                    return Brushes.Black;
            }
            else if (parameter is DataRecord)
            {
                DataRecord dRec = (DataRecord)parameter;
                decimal budgetedHours = System.Convert.ToDecimal(dRec.Cells["LaborHours"].Value);
                decimal enteredHours = System.Convert.ToDecimal(dRec.Cells["EnteredHours"].Value);
                if (enteredHours < budgetedHours)
                    return Brushes.Green;
                else if (enteredHours > budgetedHours)
                    return Brushes.Red;
                else
                    return Brushes.Black;
            }
            else
                return Brushes.Black;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
